﻿Imports System.IO     'FileStream-Klasse einbinden
Imports System.Drawing.Printing

Public Class Form1
    Private EinstellungDruckseite As New PageSettings()
    Private DruckZeichenfolge As String
    Private DruckFont As New Font("Arial", 10)

    Private Sub btnÖffnen_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnÖffnen.Click
        Dim DateiPfad As String
        'Dialogfeld Öffnen anzeigen und Textdatei auswählen
        OpenFileDialog1.Filter = "Textdateien (*.txt)|*.txt"
        OpenFileDialog1.ShowDialog()
        'Sofern nicht auf Abbrechen geklickt wird, Datei aus 
        'DateiPfad-Variable laden
        If OpenFileDialog1.FileName <> "" Then
            DateiPfad = OpenFileDialog1.FileName
            Try
                'Textdatei lesen und in RichTextBox1 laden
                Dim MyFileStream As New FileStream(DateiPfad, _
                                        FileMode.Open)
                RichTextBox1.LoadFile(MyFileStream, _
                  RichTextBoxStreamType.PlainText)
                MyFileStream.Close()
                'DruckZeichenfolge initialisieren
                DruckZeichenfolge = RichTextBox1.Text
                'Schaltfläche Drucken aktivieren
                btnDrucken.Enabled = True
            Catch ex As Exception
                'Fehlermeldung anzeigen, falls Fehler auftreten
                MessageBox.Show(ex.Message)
            End Try
        End If

    End Sub

    Private Sub btnDrucken_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDrucken.Click
        Try
            'Einstellungen für Druckseite angeben
            PrintDocument1.DefaultPageSettings = EinstellungDruckseite
            'Dokument für Dialogfeld Drucken angeben und 
            'Dialogfeld anzeigen
            DruckZeichenfolge = RichTextBox1.Text
            PrintDialog1.Document = PrintDocument1
            Dim Ergebnis As DialogResult = PrintDialog1.ShowDialog()
            'Falls auf OK geklickt wird, Dokument an den Drucker senden
            If Ergebnis = DialogResult.OK Then
                PrintDocument1.Print()
            End If
        Catch ex As Exception
            'Fehlermeldung anzeigen
            MessageBox.Show(ex.Message)
        End Try

    End Sub

    Private Sub PrintDocument1_PrintPage(ByVal sender As System.Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs) Handles PrintDocument1.PrintPage
        Dim AnzahlZeichen As Integer
        Dim AnzahlZeilen As Integer
        Dim StringSeite As String
        Dim strFormat As New StringFormat()
        'Abhängig von den Seiteneinstellungen, Druckbereich der 
        'Seite definieren
        Dim Rechteck As New RectangleF( _
          e.MarginBounds.Left, e.MarginBounds.Top, _
          e.MarginBounds.Width, e.MarginBounds.Height)
        'Anhand der Bereichsdefinition ermitteln, wie viel Text 
        'auf die Seite passt
        'Höhe um eine Zeile verringern, damit der Text nicht 
        'abgeschnitten wird
        Dim GrößenMaß As New SizeF(e.MarginBounds.Width, _
                  e.MarginBounds.Height - _
                  DruckFont.GetHeight(e.Graphics))

        'Beim Zeichnen langer Zeichenfolgen, Wortumbruch aktivieren
        strFormat.Trimming = StringTrimming.Word
        'Anhand GrößenMaß berechnen, wie viele Zeilen auf die 
        'Seite passen
        e.Graphics.MeasureString(DruckZeichenfolge, DruckFont, _
            GrößenMaß, strFormat, AnzahlZeichen, AnzahlZeilen)
        'Zeichenfolge berechnen, die auf die Seite passt
        StringSeite = DruckZeichenfolge.Substring(0, AnzahlZeichen)
        'Zeichenfolge auf aktuelle Seite drucken
        e.Graphics.DrawString(StringSeite, DruckFont, _
            Brushes.Black, Rechteck, strFormat)
        'Falls mehr Text vorliegt, weitere Seiten anzeigen
        If AnzahlZeichen < DruckZeichenfolge.Length Then
            'Gedruckten Text von der Zeichenfolge subtrahieren
            DruckZeichenfolge = DruckZeichenfolge.Substring(AnzahlZeichen)
            e.HasMorePages = True
        Else
            e.HasMorePages = False
            'Der gesamte Text wurde gedruckt, daher Zeichenfolge 
            'wiederherstellen
            DruckZeichenfolge = RichTextBox1.Text
        End If

    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

    End Sub
End Class
